%define	_bindir	/bin

Summary: An enhanced version of csh, the C shell
Name: tcsh617
Version: 6.17
Release: 5%{?dist}
License: BSD
Group: System Environment/Shells
Source: ftp://ftp.astron.com/pub/tcsh/tcsh-%{version}.00.tar.gz
Patch1: tcsh-6.15.00-closem.patch
Patch3: tcsh-6.14.00-unprintable.patch
Patch4: tcsh-6.15.00-hist-sub.patch
Patch6: tcsh-6.15.00-ca-color.patch
Patch7: tcsh-6.14.00-set.patch
Patch8: tcsh-6.14.00-syntax.patch
Patch9: tcsh-6.13.00-memoryuse.patch
Patch11: tcsh-6.14.00-order.patch
Patch12: tcsh-6.15.00-rs-color.patch
Patch13: tcsh-6.17.00-mh-color.patch
Patch14: tcsh-6.17.00-glob-automount.patch
Patch15: tcsh-6.17.00-printexitvalue.patch
Patch16: tcsh-6.17.00-testsuite.patch
Patch17: tcsh-6.17.00-negative_jobs.patch
Patch20: tcsh-6.17.00-status-pipeline-backquote-list-of-cmds.patch
Patch21: tcsh-6.17.00-dont-set-empty-remotehost.patch
Patch22: tcsh-6.17.00-dont-print-history-on-verbose.patch
Patch23: tcsh-6.17.00-extrafork.patch
Patch24: tcsh-6.17.00-avoid-infinite-loop-pendjob-xprintf.patch
Patch25: tcsh-6.17.00-variable-names.patch
Patch26: tcsh-6.17.00-manpage-fixes.patch
Patch27: tcsh-6.17.00-termcap.patch
Patch28: tcsh-6.17.00-avoid-null-cwd.patch
Conflicts: tcsh < 6.17
Provides: tcsh = %{version}
Provides: csh = %{version}
Requires: libtermcap
Requires(post): grep
Requires(postun): coreutils, grep
URL: http://www.tcsh.org/
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: autoconf, automake, libtermcap-devel, gettext-devel

%description
Tcsh is an enhanced but completely compatible version of csh, the C
shell.  Tcsh is a command language interpreter which can be used both
as an interactive login shell and as a shell script command processor.
Tcsh includes a command line editor, programmable word completion,
spelling correction, a history mechanism, job control and a C language
like syntax.

%prep
%setup -q -n tcsh-%{version}.00
%patch1 -p1 -b .closem
%patch3 -p1 -b .unprintable
%patch4 -p1 -b .hist-sub
%patch6 -p1 -b .ca-color
%patch7 -p1 -b .set
%patch8 -p1 -b .syntax
%patch9 -p1 -b .memoryuse
%patch11 -p1 -b .order
%patch12 -p1 -b .rs-color
%patch13 -p1 -b .mh-color
%patch14 -p1 -b .glob-automount
%patch15 -p1 -b .printexitvalue
%patch16 -p1 -b .testsuite
%patch17 -p1 -b .negative_jobs
%patch21 -p1 -b .dont-set-empty-remotehost
%patch20 -p1 -b .status-pipeline-backquote-list-of-cmds
%patch22 -p1 -b .dont-print-history-on-verbose
%patch23 -p1 -b .extra-fork
%patch24 -p1 -b .avoid-infinite-loop-pendjob-xprintf
%patch25 -p1 -b .variable-names
%patch26 -p1 -b .manpage-fixes
%patch27 -p1 -b .termcap
%patch28 -p1 -b .avoid-null-cwd

for i in Fixes WishList; do
 iconv -f iso-8859-1 -t utf-8 "$i" > "${i}_" && \
 touch -r "$i" "${i}_" && \
 mv "${i}_" "$i"
done

%build
%configure --without-hesiod
make %{?_smp_mflags} all
make %{?_smp_mflags} -C nls catalogs

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man1 ${RPM_BUILD_ROOT}%{_bindir}
install -p -m 755 tcsh ${RPM_BUILD_ROOT}%{_bindir}/tcsh
install -p -m 644 tcsh.man ${RPM_BUILD_ROOT}%{_mandir}/man1/tcsh.1
ln -sf tcsh ${RPM_BUILD_ROOT}%{_bindir}/csh
ln -sf tcsh.1 ${RPM_BUILD_ROOT}%{_mandir}/man1/csh.1

while read lang language ; do
	dest=${RPM_BUILD_ROOT}%{_datadir}/locale/$lang/LC_MESSAGES
	if test -f tcsh.$language.cat ; then
		mkdir -p $dest
		install -p -m 644 tcsh.$language.cat $dest/tcsh
		echo "%lang($lang) %{_datadir}/locale/$lang/LC_MESSAGES/tcsh"
	fi
done > tcsh.lang << _EOF
de german
el greek
en C
es spanish
et et
fi finnish
fr french
it italian
ja ja
pl pl
ru russian
uk ukrainian
_EOF

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ ! -f /etc/shells ]; then
 echo "%{_bindir}/tcsh" >> /etc/shells
 echo "%{_bindir}/csh"	>> /etc/shells
else
 grep -q '^%{_bindir}/tcsh$' /etc/shells || \
 echo "%{_bindir}/tcsh" >> /etc/shells
 grep -q '^%{_bindir}/csh$'  /etc/shells || \
 echo "%{_bindir}/csh"	>> /etc/shells
fi

%postun
if [ ! -x %{_bindir}/tcsh ]; then
 grep -v '^%{_bindir}/tcsh$'  /etc/shells | \
 grep -v '^%{_bindir}/csh$' > /etc/shells.rpm && \
 mv /etc/shells.rpm /etc/shells
fi

%files -f tcsh.lang
%defattr(-,root,root,-)
%doc BUGS Copyright FAQ Fixes NewThings WishList complete.tcsh README
%{_bindir}/tcsh
%{_bindir}/csh
%{_mandir}/man1/*.1*

%changelog
* Mon May 23 2011 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 6.17-5
- Avoid possible null dereference for cwd
  Resolves: #689382

* Mon May 02 2011 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 6.17-4
- Fix requires not to depend on /usr/lib* libraries
- Build with libtermcap-devel instead of ncurses-devel

* Thu Apr 14 2011 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 6.17-3
- Fix status of pipelined/backquoted/list of commands
  Resolves: #638955
- Don't allow illegal variable names to be set
  Resolves: #436901
- Minor manpage fixes
  Resolves: #437079, #437080, #436439, #433908

* Thu Mar 24 2011 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 6.17-2
- Avoid infinite loop pendjob()-xprintf() when stdout is closed
  Resolves: #690500

* Wed Mar 16 2011 Vojtech Vitek (V-Teq) <vvitek@redhat.com> - 6.17-1
- Import new package tcsh617, based on tcsh-6.17-12.el6
- Link to libtermcap instead of libtinfo
- Ship Copyright file
- Remove extra fork when tcsh processes backquotes
  Resolves: #688170
- Don't print history in verbose mode (upstream patch)
  Resolves: #688173
- Don't set $REMOTEHOST on the local machine
  Resolves: #688175
- Fix negative number of jobs with %%j formatting parameter in prompt
- Fix testsuite
- Fix tcsh obeys printexitvalue for back-ticks
- Ship README file
- Fix tcsh globbing causing bad automount
- Add new colorls variable
